#!/usr/bin/env python

import math

gms = 39.47841760
M_S = 1.989e30
M_E = 5.972e24
deg = math.pi/180.0

def Sd_func(a, e, i, m):
    N = len(a)
    Sd = 0.0
    s = 0.0
    for j in xrange(0,N):
        Sd += m[j]*math.sqrt(a[j])*(1.0-math.sqrt(1.0-e[j]**2)*math.cos(i[j]))
        s += m[j]*math.sqrt(a[j])
    Sd /= s
    return Sd

def follow(filename):
    a = []
    e = []
    i = []
    m = []
    f = open(filename, "r")
    for line in f.readlines():
        l = line.split()
        j = int(l[0])
        t = float(l[1])
        a.append(float(l[2]))
        e.append(float(l[3]))
        i.append(float(l[4])*deg)
        m.append(float(l[8]))
    f.close()
    return a, e, i, m

def readss(filename):
    a = []
    e = []
    i = []
    m = []
    f = open(filename, "r")
    for line in f.readlines():
        l = line.split()
        j = int(l[1])
        t = float(l[0])
        a.append(float(l[2]))
        e.append(float(l[3]))
        i.append(float(l[4])*deg)
        m.append(float(l[5]))
    f.close()
    return a, e, i, m

def main():
    f = open("Sd.out", "w")
    f.write("# id & Sd [] & N_pl\n")

    a, e, i, m = readss("plt/ss.dat")
    Sd = Sd_func(a, e, i, m)
    f.write("# ss.dat	%.6f	%d\n" % (Sd, len(a)))

    for j in xrange(0,50):
        a, e, i, m = follow("%03d/final.out" % (j+1))
        Sd = Sd_func(a, e, i, m)
        f.write("%03d	%.6f	%d\n" % (j+1, Sd, len(a)))

    f.close()

if __name__ == "__main__":
    main()

