#!/usr/bin/env python

"""
discard_m.py
Accretion derived from discrad_mass.out.
Miroslav Broz (miroslav.broz@email.cz), May 29th 2020

"""

import sys

gms = 39.47841760
M_S = 1.989e30
M_E = 5.972e24
fac = 1.0/gms*M_S/M_E

def discard(filename):

    ids = {}
    for i in xrange(0,29+1):
        ids[i] = [i]
    print "ids = ", ids

    f = open("initial.out", "r")
    ms = {}
    for line in f.readlines():
        l = line.split()
        id_ = abs(int(l[0]))
        ms[id_] = float(l[8])
    f.close()

    f = open(filename, "r")
    f2 = open("discard_m.out", "w")
    f2.write("# no t [yr]          m1     m2     m [m_E]  id1 id2  N1 N2    ids\n")

    k = 0
    while True:
       
        try: 
            l = f.readline().split()
            t = float(l[0])
        except (IOError,IndexError) as ex:
#            print ex
            break

        k += 1
        l = f.readline().split()
        id1 = int(l[1])
        m1 = float(l[2])*fac
        l = f.readline().split()
        l = f.readline().split()

        l = f.readline().split()
        id2 = int(l[1])
        m2 = float(l[2])*fac
        l = f.readline().split()
        l = f.readline().split()

        l = f.readline().split()
        id_ = int(l[1])
        m_ = float(l[2])*fac
        l = f.readline().split()
        l = f.readline().split()

        n = len(ids)

        print ""
        print "t = ", t
        print "id1 = ", id1
        print "id2 = ", id2
        print "id_ = ", id_
        print "n = ", n
        print "ids = ", ids
        print ""

        f2.write("%2d %.10e  %.4f %.4f %.4f   %2d  %2d  %2d  %2d   " % (k, t, m1, m2, m_, id1, id2, len(ids[id1]), len(ids[id2])))
        tmp = ids[id1][:]
        tmp.sort()
        for j in xrange(0,len(tmp)):
            f2.write(" %2d" % (tmp[j]))
        f2.write(" ||")
        tmp = ids[id2][:]
        tmp.sort()
        for j in xrange(0,len(tmp)):
            f2.write(" %2d" % (tmp[j]))
        f2.write("\n")

        if id_ == id1:
            ids[id1] += ids[id2]
            ids.pop(id2)
            for i in xrange(id2+1,n):
                ids[i-1] = ids[i]
            if id2 < n-1:
                ids.pop(n-1)
        else:
            print "Error: Merged particle does NOT have id = id1!"
            sys.exit(1)

        print "ids = ", ids

    print ""
    for i in xrange(2,len(ids)):
        f2.write("#  %.10e                         %2d      %2d       " % (t, i, len(ids[i])))
        tmp = ids[i][:]
        tmp.sort()
        for j in xrange(0,len(tmp)):
            f2.write(" %2d" % (tmp[j]))
        f2.write("\n")
        
    f.close()
    f2.close()

def main():
    discard("discard_mass.out")

if __name__ == "__main__":
    main()


